/**
 * Food order backend
 * Food order platform
 *
 * OpenAPI spec version: 0.0.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import {Inject, Injectable, Optional} from '@angular/core';
import {HttpClient, HttpEvent, HttpHeaders, HttpParams, HttpResponse} from '@angular/common/http';

import {Observable} from 'rxjs/Observable';
import {Order} from '../model/order';

import {BASE_PATH} from '../variables';
import {Configuration} from '../configuration';
import {CustomHttpUrlEncodingCodec} from "../encoder";


@Injectable()
export class OrderControllerService {

  protected basePath = 'https://calm-dusk-20347.herokuapp.com';
  public defaultHeaders = new HttpHeaders();
  public configuration = new Configuration();

  constructor(protected httpClient: HttpClient, @Optional() @Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
    if (basePath) {
      this.basePath = basePath;
    }
    if (configuration) {
      this.configuration = configuration;
      this.basePath = basePath || configuration.basePath || this.basePath;
    }
  }

  /**
   * @param consumes string[] mime-types
   * @return true: consumes contains 'multipart/form-data', false: otherwise
   */
  private canConsumeForm(consumes: string[]): boolean {
    const form = 'multipart/form-data';
    for (let consume of consumes) {
      if (form === consume) {
        return true;
      }
    }
    return false;
  }


  /**
   * approveOrder
   *
   * @param id id
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public approveOrderUsingPUT(id: number, observe?: 'body', reportProgress?: boolean): Observable<Order>;
  public approveOrderUsingPUT(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Order>>;
  public approveOrderUsingPUT(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Order>>;
  public approveOrderUsingPUT(id: number, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    if (id === null || id === undefined) {
      throw new Error('Required parameter id was null or undefined when calling approveOrderUsingPUT.');
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = [
      '*/*'
    ];
    let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set("Accept", httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header
    let consumes: string[] = [
      'application/json'
    ];

    return this.httpClient.put<Order>(`${this.basePath}/api/orders/${encodeURIComponent(String(id))}/approve`,
      null,
      {
        withCredentials: this.configuration.withCredentials,
        headers: headers,
        observe: observe,
        reportProgress: reportProgress
      }
    );
  }

  /**
   * rejectOrder
   *
   * @param id id
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public rejectOrderUsingPUT(id: number, reason: string, observe?: 'body', reportProgress?: boolean): Observable<Order>;
  public rejectOrderUsingPUT(id: number, reason: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Order>>;
  public rejectOrderUsingPUT(id: number, reason: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Order>>;
  public rejectOrderUsingPUT(id: number, reason: string, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    if (id === null || id === undefined) {
      throw new Error('Required parameter id was null or undefined when calling rejectOrderUsingPUT.');
    }
    if (reason === null || reason === undefined) {
      throw new Error('Required parameter reason was null or undefined when calling rejectOrderUsingPUT.');
    }

    let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
    if (reason !== undefined) {
      queryParameters = queryParameters.set('reason', <any>reason);
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = [
      '*/*'
    ];
    let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set("Accept", httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header
    let consumes: string[] = [
      'application/json'
    ];

    return this.httpClient.put<Order>(`${this.basePath}/api/orders/${encodeURIComponent(String(id))}/reject`,
      null,
      {
        params: queryParameters,
        withCredentials: this.configuration.withCredentials,
        headers: headers,
        observe: observe,
        reportProgress: reportProgress
      }
    );
  }

  /**
   * getOrders
   *
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public getOrdersUsingGET(observe?: 'body', reportProgress?: boolean): Observable<Array<Order>>;
  public getOrdersUsingGET(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Order>>>;
  public getOrdersUsingGET(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Order>>>;
  public getOrdersUsingGET(observe: any = 'body', reportProgress: boolean = false): Observable<any> {

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = [
      '*/*'
    ];
    let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set("Accept", httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header
    let consumes: string[] = [
      'application/json'
    ];

    return this.httpClient.get<Array<Order>>(`${this.basePath}/api/orders`,
      {
        withCredentials: this.configuration.withCredentials,
        headers: headers,
        observe: observe,
        reportProgress: reportProgress
      }
    );
  }

  /**
   * create
   *
   * @param request request
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public createUsingPOST(request: any, observe?: 'body', reportProgress?: boolean): Observable<Order>;
  public createUsingPOST(request: any, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Order>>;
  public createUsingPOST(request: any, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Order>>;
  public createUsingPOST(request: any, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    if (request === null || request === undefined) {
      throw new Error('Required parameter request was null or undefined when calling createUsingPOST.');
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = [
      '*/*'
    ];
    let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set("Accept", httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header
    let consumes: string[] = [
      'application/json'
    ];
    let httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
    if (httpContentTypeSelected != undefined) {
      headers = headers.set("Content-Type", httpContentTypeSelected);
    }

    return this.httpClient.post<Order>(`${this.basePath}/api/orders`,
      request,
      {
        withCredentials: this.configuration.withCredentials,
        headers: headers,
        observe: observe,
        reportProgress: reportProgress
      }
    );
  }

}
